#pragma once

class CVector3
{
public:
	void SetVector( const double x, const double y, const double z ) { X = x; Y = y; Z = z; }
	double GetNorm() const;	
	void Normalize();

	CVector3 operator + ( CVector3& v );
	CVector3 operator - ( CVector3& v );
	CVector3 operator ^ ( CVector3& v ); 
	double&	operator[] ( int idx );

	double X, Y, Z;
};

class CCamera
{
public:
    CCamera(void);
    virtual ~CCamera(void);

    void ResetCamera();

    void BeginDrag(const CPoint& _point);
    void EndDrag();
    BOOL MouseMove(const CPoint& _point);

    void BeginZoom(const CPoint& _point);
    void EndZoom();

    void SetWindowSize(const int _cx, const int _cy) { m_szWindowSize.cx = _cx; m_szWindowSize.cy = _cy; }

    const CVector3 GetEyeDirection() const {return m_vEyeDirection; }

    const float GetDistance() const { return m_fDistance; };

    BOOL IsCaptured() const { return (m_bCapture || m_bZoom); };

	GLfloat m_matTrackBall[4][4];

private:
    CVector3 TrackBallMapping(const CPoint& _point);
    
    CVector3 m_vOldPoint;

    BOOL m_bCapture;
    BOOL m_bZoom;

    SIZE m_szWindowSize;

    CVector3 m_vEyeDirection;

    float m_fDistance;

    const float m_fTrackballSize;
    const float m_fZoomScale;
};
