// OpenGL3DControl.cpp: implementation of the COpenGL3DControl class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <math.h>
#include "program3.h"
#include "OpenGL3DControl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

COpenGL3DControl::COpenGL3DControl()
{
}

COpenGL3DControl::~COpenGL3DControl()
{

}

void COpenGL3DControl::DrawGrid()
{
	glLineWidth( 2.0f );
	glBegin( GL_LINES );
		// X-axis
		glColor3f( 1.0f, 0.0f, 0.0f );
		glVertex3i( 0, 0, 0 );
		glVertex3i(10, 0, 0 );
		// Y-axis
		glColor3f( 0.0f, 1.0f, 0.0f );
		glVertex3i( 0, 0, 0 );
		glVertex3i( 0,10, 0 );
		// Z-axis
		glColor3f( 0.0f, 0.0f, 1.0f );
		glVertex3i( 0, 0, 0 );
		glVertex3i( 0, 0,10 );
	glEnd();
}

void COpenGL3DControl::SetupViewTransform()
{
	glMultMatrixf( (GLfloat *) m_Camera.m_matTrackBall );  
}

void COpenGL3DControl::DrawScene()
{
	glBegin( GL_POLYGON );
		glColor3f( 0.5f, 0.5f, 0.5f );
		glVertex2f( -2.5, -2.5 );
		glVertex2f( 0, -2.5 );
		glVertex2f( 1.0, 1.0 );
		glVertex2f( -1.0, 2.5 );
		glVertex2f( -0.5, -0.5 );
	glEnd();
}

void COpenGL3DControl::SetupViewFrustum()
{
	const GLdouble dFovy = 60;
	const GLdouble dAspect = 1.0;
	const GLdouble dNear = 1.0;
	const GLdouble dFar = 100.0;

	GLdouble dFov2, dLeft, dRight, dTop, dBottom;
    dFov2 = ((dFovy*PI) / 180.0) / 2.0;
    dTop = dNear / (cos(dFov2) / sin(dFov2));
    dBottom = -dTop;
    dRight = dTop * dAspect;
    dLeft = -dRight;

	GLdouble dXwsize, dYwsize; 
    GLint iViewport[4];
    glGetIntegerv (GL_VIEWPORT, iViewport);
    dXwsize = dRight - dLeft;
    dYwsize = dTop - dBottom;
    glFrustum (dLeft, dRight, dBottom, dTop, dNear, dFar);

	glTranslatef(0,0,-m_Camera.GetDistance());
	m_Camera.SetWindowSize(m_rect.right, m_rect.bottom);
}

void COpenGL3DControl::LButtonDown( CPoint point )
{
	m_Camera.BeginDrag(point);
}

void COpenGL3DControl::LButtonUp( CPoint point )
{
	m_Camera.EndDrag();
}

void COpenGL3DControl::RButtonDown( CPoint point )
{
	m_Camera.BeginZoom(point);
}

void COpenGL3DControl::RButtonUp( CPoint point )
{
	m_Camera.EndZoom();
}

void COpenGL3DControl::MouseMove( UINT nFlags, CPoint point )
{
	wglMakeCurrent( m_hDC, m_hRC );
	m_Camera.MouseMove(point);
	wglMakeCurrent( 0, 0 );

	Invalidate(FALSE);
}