// OpenGLControl.cpp : implementation file
//

#include "stdafx.h"
#include "program3.h"
#include "OpenGLControl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenGLControl

COpenGLControl::COpenGLControl()
{

}

COpenGLControl::~COpenGLControl()
{
}


BEGIN_MESSAGE_MAP(COpenGLControl, CButton)
	//{{AFX_MSG_MAP(COpenGLControl)
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenGLControl message handlers

void COpenGLControl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	wglMakeCurrent( m_hDC, m_hRC );
	{
		glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
		glMatrixMode( GL_PROJECTION );
		glLoadIdentity();
			SetupViewFrustum();

		glMatrixMode( GL_MODELVIEW );
		glLoadIdentity();
			SetupViewTransform();
		
		glPushMatrix();
			DrawGrid();
		glPopMatrix();

		glPushMatrix();
			DrawScene();
		glPopMatrix();

		glFinish();
		SwapBuffers( m_hDC );
	}
	wglMakeCurrent( 0, 0 );
	
}

void COpenGLControl::OnDestroy() 
{
	CButton::OnDestroy();
	
	DestroyOpenGLObjects();
}

void COpenGLControl::InitOpenGLObjects()
{
	PIXELFORMATDESCRIPTOR pfd =
    {
	    sizeof(PIXELFORMATDESCRIPTOR),
	    1,
	    PFD_DRAW_TO_WINDOW|
	    PFD_SUPPORT_OPENGL|
	    PFD_DOUBLEBUFFER,  
	    PFD_TYPE_RGBA,
	    32,
	    0,0,0,0,0,0,
	    1,0,
	    0,0,0,0,0,
	    32,
	    0,0,
	    PFD_MAIN_PLANE,
	    0,
	    0,0,0
    };
    
    m_pDC = new CClientDC(this); 
	m_hDC = m_pDC->GetSafeHdc();
    int pixelFormat = ChoosePixelFormat(m_hDC, &pfd);
    SetPixelFormat(m_hDC, pixelFormat, &pfd);
    m_hRC = wglCreateContext(m_hDC);

	GetClientRect(&m_rect);
	SetupViewport( m_rect.right, m_rect.bottom );

    wglMakeCurrent(m_hDC,m_hRC);
		glClearColor( 1.0f, 1.0f, 1.0f, 1.0f );
	wglMakeCurrent( 0, 0 );
}

void COpenGLControl::DestroyOpenGLObjects()
{
	wglMakeCurrent( 0, 0 );
	wglDeleteContext( m_hRC );
	if ( m_pDC )
		delete m_pDC;
}

void COpenGLControl::DrawGrid()
{
}

void COpenGLControl::SetupViewTransform()
{
}

void COpenGLControl::DrawScene()
{
}

void COpenGLControl::SetupViewFrustum()
{
}

void COpenGLControl::SetupViewport( int w, int h )
{
	wglMakeCurrent( m_hDC, m_hRC );
		glViewport( 0, 0, w, h );
	wglMakeCurrent( 0, 0 );
}

void COpenGLControl::GetWorldCoord( CPoint point, double* pNear, double* pFar )
{
	double mvmat[16], promat[16];
	int viewport[4];
	int x, y;
	x = point.x;
	y = m_rect.bottom-point.y;

	// Opengl Support Mode.
	wglMakeCurrent( m_hDC, m_hRC );
	{ 
		// get viewport
		glGetIntegerv( GL_VIEWPORT, viewport );
		// get current model view matrix.
		glGetDoublev( GL_MODELVIEW_MATRIX, mvmat );
		// get current projection matrix.
		glGetDoublev( GL_PROJECTION_MATRIX, promat );  
		gluUnProject( (double)x, (double)y, 0.0, mvmat, promat, viewport, &pNear[0], &pNear[1], &pNear[2] );
		gluUnProject( (double)x, (double)y, 1.0, mvmat, promat, viewport, &pFar[0], &pFar[1], &pFar[2] );
	}
	wglMakeCurrent( 0, 0 );

	CString str;
	str.Format( "World coordinate of near point : ( %3.2f, %3.2f, %3.2f )", pNear[0], pNear[1], pNear[2] );
	AfxMessageBox( str );

	str.Format( "World coordinate of far point : ( %3.2f, %3.2f, %3.2f )", pFar[0], pFar[1], pFar[2] );
	AfxMessageBox( str );
}

void COpenGLControl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	LButtonDown( point );
}

void COpenGLControl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	LButtonUp( point );
	
	CButton::OnLButtonUp(nFlags, point);
}

void COpenGLControl::OnMouseMove(UINT nFlags, CPoint point) 
{
	MouseMove( nFlags, point );
	
	CButton::OnMouseMove(nFlags, point);
}

void COpenGLControl::OnRButtonDown(UINT nFlags, CPoint point) 
{
	RButtonDown( point );
	
	CButton::OnRButtonDown(nFlags, point);
}

void COpenGLControl::OnRButtonUp(UINT nFlags, CPoint point) 
{
	RButtonUp( point );
	
	CButton::OnRButtonUp(nFlags, point);
}

void COpenGLControl::LButtonDown( CPoint point )
{
}

void COpenGLControl::LButtonUp( CPoint point )
{
}

void COpenGLControl::RButtonDown( CPoint point )
{
}

void COpenGLControl::RButtonUp( CPoint point )
{
}

void COpenGLControl::MouseMove( UINT nFlags, CPoint point )
{
}